
/*	Copyright (C) G. Jespersen
	See Licence.txt.*/

// 
// File not compatable with VLC version
//

/////////////////////////////////////////////////////////////////////////////
// DataView.h : interface of the CDataView class


#if !defined(AFX_DATAVIEW_H__838B34E0_EE79_48B8_A2CA_355BA339EBC6__INCLUDED_)
#define AFX_DATAVIEW_H__838B34E0_EE79_48B8_A2CA_355BA339EBC6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Doc.h"
#include "Player.h"
//#include "ProgressDlg.h"	// 12/13/14
#include "TextSel.h"		// 10/04/2017


class CDataView : public  CScrollView
{
protected: // create from serialization only
	CDataView();
	DECLARE_DYNCREATE(CDataView)

// Attributes
public:
	CDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDataView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDataView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDataView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnSetupFont();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnEditCopy();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnFileOpen();
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	//}}AFX_MSG

	// DS callback
	LRESULT OnVideoEvent(WPARAM wParam, LPARAM lParam);				// WM_USER_VIDEOEVENT

	// From Main Frame
	LRESULT OnSetActivate(WPARAM wParam, LPARAM lParam);			// WM_USER_SET_ACTIVATE

	// From controls bar.
	LRESULT OnPlaybackStart(WPARAM wParam, LPARAM lParam);			// WM_USER_VID_START
	LRESULT OnPlaybackStop(WPARAM wParam, LPARAM lParam);			// WM_USER_VID_STOP
	LRESULT OnPlaybackPause(WPARAM wParam, LPARAM lParam);			// WM_USER_VID_PAUSE	
	LRESULT OnPlaybackMute(WPARAM wParam, LPARAM lParam);			// WM_USER_VID_MUTE	
	LRESULT OnPlaybackTime(WPARAM wParam, LPARAM lParam);			// WM_USER_VID_TIME	
	LRESULT OnPlaybackVol(WPARAM wParam, LPARAM lParam);			// WM_USER_VID_VOL	
	DECLARE_MESSAGE_MAP()

private:
	void	ControlsBarEnable();
	void	ControlsBarDisable();

public:
	void	StartVideoPlayback(const CString & path, BOOL playUrl);
//	void	PlayVideoStream(const CString & path);	//12/13/14
	void	StopVideoPlayback();
	void	ToggleVideoPlaybackPause();
	BOOL	IsVideoRunningOrPaused() { return m_player.IsRunningOrPaused(); };

public:
	// View text display.
	void	FormatRawText(CDC * pDC);
	void	DrawBuffer(CDC * pDC);	// 10/04/2017

	// Scrolling
	void	SetScrollViewSize();
	BOOL	ScrollBarShowing();
	BOOL	m_scrollResizing; // test resize

	// DirectShow
	BOOL	m_redrawVid;
	BOOL	m_isKhanVideo;

	// Files List
	void	ToggleFilesList();

	// Response progress dialog - 12/13/14
//	void	StartResponseProgress();
//	void	StopResponseProgress();

public:
	CFont m_font;

private:

	// DirectShow
	CPlayer m_player;

	// View.
	COLORREF m_vidBkgColor;

	// View text display.
	CStringArray m_strAr;
	BOOL m_formatText;
	CSize	m_textOffset;	// 10/04/2017
	CBitmap m_screenBitmap;	// 10/04/2017

	// 10/04/2017 - search this date for all relevent text selection code
	// Text selection 
	CTextSel m_textSel;

	// Response progress dialog - 12/13/14
//	CProgressDlg m_progressDlg;
//	int m_progStep;

	// Test stuff - save.
	afx_msg void OnTest();
};

#ifndef _DEBUG  // debug version in DataView.cpp
inline CDoc* CDataView::GetDocument()
   { return (CDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DATAVIEW_H__838B34E0_EE79_48B8_A2CA_355BA339EBC6__INCLUDED_)
