// ConvertVidFileNamesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "khan.h"
#include "ConvertVidFileNamesDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// CFileNames
CFileNames::CFileNames()
{
	Zero();
}
CFileNames::~CFileNames()
{
}
CFileNames::CFileNames(const CFileNames & fileNames)
{
	Copy(fileNames);
}

void CFileNames::operator=(const CFileNames & fileNames)
{
	Copy(fileNames);
}
BOOL CFileNames::operator==(const CFileNames & fileNames)
{
	if(m_oldName == fileNames.m_oldName &&
	   m_newName == fileNames.m_newName )
		return TRUE;
	return FALSE;

}
BOOL CFileNames::operator!=(const CFileNames & fileNames)
{
	return !(*this == fileNames);
}
void CFileNames::Copy(const CFileNames & fileNames)
{
	m_oldName = fileNames.m_oldName;
	m_newName = fileNames.m_newName;
}
void CFileNames::Zero()
{
	m_oldName.Empty();
	m_newName.Empty();
}



/////////////////////////////////////////////////////////////////////////////
// CConvertVidFileNamesDlg dialog


CConvertVidFileNamesDlg::CConvertVidFileNamesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConvertVidFileNamesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConvertVidFileNamesDlg)
	m_infoStr = _T("");
	m_headerStr = _T("");
	//}}AFX_DATA_INIT
}


void CConvertVidFileNamesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConvertVidFileNamesDlg)
	DDX_Control(pDX, IDC_BUTTON_RENAME, m_ctrlRename);
	DDX_Control(pDX, IDC_PROGRESS_CONVERT, m_ctrlProgress);
	DDX_Text(pDX, IDC_STATIC_INFO, m_infoStr);
	DDX_Text(pDX, IDC_STATIC_HEADER, m_headerStr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConvertVidFileNamesDlg, CDialog)
	//{{AFX_MSG_MAP(CConvertVidFileNamesDlg)
	ON_BN_CLICKED(IDC_BUTTON_RENAME, OnButtonRename)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConvertVidFileNamesDlg message handlers

BOOL CConvertVidFileNamesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
		return TRUE;

	// Ensure no vid playback, or downloading.

	// Build a list of files to convert.
	//
	// Could be 3000 files.
	m_fileNamesAr.SetSize(0, 512);
	CFileNames names;

	CTopicTree & tree = pDoc->GetTree();
	CString vidStore = pDoc->m_videoStorePath;
	vidStore += _T("\\");

	WIN32_FIND_DATA	FindData;
	HANDLE	hFiles;
	UINT	nFileCount = 0;
	UINT	orphans = 0;
	CString fileName, newFileName, temp;
	CVideo video;
	CStringArray oldName;
	CStringArray newName;
	CString errMsg;
	BOOL noStorage = FALSE;

	CString dir = vidStore;
	dir += _T("*");
	if((hFiles = FindFirstFile(dir, &FindData)) != INVALID_HANDLE_VALUE) //0xffffffff NULL)//
	{
		while(FindNextFile(hFiles, &FindData))
		{
			// Watch for this or other directories.
			if(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
				continue;

			// Get the file name.
			fileName = FindData.cFileName;

			// Ensure an mp4.
			if(fileName.Find(_T(".mp4"), 0) == -1)
				continue;

			// If in the db as the old style Title file name.
			if(tree.VideoFileUsedTitle(fileName, &video))
			{
				// If we can get the new style name.				
				if(video.GetShortFileName(newFileName))
				{
					// Save old and new mp4 names to array.
					names.m_oldName = vidStore;
					names.m_oldName += fileName;

					names.m_newName = vidStore;
					names.m_newName += newFileName;

					m_fileNamesAr.Add(names);
				}
			}
		}
		FindClose(hFiles);
	}
	// No video storage
	else
	{
		noStorage = TRUE;
	}

	// If names gotten.
	int sz = m_fileNamesAr.GetSize();
	if(sz)
	{
		//
		// Note: Delete permissions are required.
		//
		if(pDoc->IsAdmin())
		{
			m_headerStr = _T("Rename your video files to their Khan Server file name.\n")
						  _T("Note renaming cannot be undone.\n")
						  _T("Please see the Help file for more information.");
		}
		else
		{
			m_headerStr = _T("Rename your video files to their Khan Server file name.\n")
						  _T("Administrator privileges may be required.\n")
						  _T("Note renaming cannot be undone.\n")
						  _T("Please see the Help file for more information.");
		}

		m_infoStr.Format(_T("%d video files in:\n")
						 _T("  %s\n")
						 _T("require renaming for Khan Desktop to utilize them."),
							sz, pDoc->m_videoStorePath);
		m_ctrlProgress.SetRange32(0, sz);
		m_ctrlProgress.SetStep(1);
	}
	else
	{
		if(noStorage)
			m_infoStr = _T("No video file storage found.");
		else
			m_infoStr = _T("No video files require renaming.");
		m_ctrlRename.EnableWindow(FALSE);
	}
	// Set dlg.
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConvertVidFileNamesDlg::OnButtonRename() 
{
	// TODO: Add your control notification handler code here

	int sz = m_fileNamesAr.GetSize();
	BOOL error = FALSE;
	for(int i = 0; i < sz; i ++)
	{
		m_ctrlProgress.StepIt();
		CFileNames & names = m_fileNamesAr[i];


		if(!MoveFileEx(names.m_oldName, names.m_newName, 
					   MOVEFILE_COPY_ALLOWED | MOVEFILE_REPLACE_EXISTING))
		{
			DWORD err = GetLastError();

			// Format last error.
			LPVOID lpMsgBuf;
			FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
						  FORMAT_MESSAGE_FROM_SYSTEM	 |
						  FORMAT_MESSAGE_IGNORE_INSERTS,
						  NULL,
						  err,
						  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						  (LPTSTR) &lpMsgBuf,
						  0,
						  NULL);
			m_infoStr.Format(_T("Could not rename video files.\n%s"), lpMsgBuf);

			// Clean up.
			LocalFree(lpMsgBuf);

			// Break out.
			error = TRUE;
			break;
		}
	}
	// Ok
	if(!error)
	{
		m_infoStr.Format(_T("%d video files renamed."), sz);
	}

	// Info user
	m_ctrlRename.EnableWindow(FALSE);
	m_ctrlProgress.SetPos(0);
	UpdateData(FALSE);

	
}
